#!/usr/bin/env python

###########################################################################
##                                                                       ##
## Copyrights yoann ARNAUD <yarnaud@crans.org> 2009                      ##
##                                                                       ##
## This program is free software: you can redistribute it and/or modify  ##
## it under the terms of the GNU General Public License as published by  ##
## the Free Software Foundation, either version 3 of the License, or     ##
## (at your option) any later version.                                   ##
##                                                                       ##
## This program is distributed in the hope that it will be useful,       ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of        ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         ##
## GNU General Public License for more details.                          ##
##                                                                       ##
## You should have received a copy of the GNU General Public License     ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>. ##
##                                                                       ##
###########################################################################

import Tkinter, tkFileDialog, tkFont, tkMessageBox, sys, os, re

def SplitXmlLine(ligne):
    d = {}
    ligne = ligne.split(" ", 1)[1].split("\"")[:-1]
    for i in range(len(ligne)/2):
        key = ligne[2*i].strip("=").strip()
        val = ligne[2*i+1]
        d[key] = val
    return d

def cmp_label(un, unautre):
    return cmp(un["label"], unautre["label"])

def TransformeFichier(src, dst):

    Places = []
    ArcsPlaceTransition = []
    ArcsTransitionPlace = []
    Transitions = []

    f = open(src)
    for ligne in f.readlines():
        ligne=ligne.strip()
        if ligne.startswith("<place"):
            Places.append(SplitXmlLine(ligne))
        if ligne.startswith("<arc") and "TransitionPlace" in ligne:
            ArcsTransitionPlace.append(SplitXmlLine(ligne))
        if ligne.startswith("<arc") and "PlaceTransition" in ligne:
            ArcsPlaceTransition.append(SplitXmlLine(ligne))
        if ligne.startswith("<transition"):
            Transitions.append(SplitXmlLine(ligne))

    if len(Places) == 0:
        AllErreur(" No places found\n Have you selected a good xml file ?\n")
    elif len(Transitions) == 0:
        AllErreur(" No transitions found\n Have you selected a good xml file ?\n")

    RegExpNamePlace = re.compile('^P[0-9]+_[0-9]+$')
    for place in Places:
        if RegExpNamePlace.match(place["label"]) == None:
            AllErreur(" Please correct the syntax of the place names (" + place["label"] + ")\n Should be something like \"P1_10\", \"P12_3\", etc.\n\n")
    RegExpTransName = re.compile('[uxy][0-9]+')
    for transition in Transitions:
        if RegExpTransName.match(transition["label"]) == None:
            AllErreur(" Please correct the syntax of the transition names (" + transition["label"] + ")\n Should be something like \"u5\", \"x18\", \"y2\" etc.\n\n")

    #taille de A B C
    TransEntrees = [x for x in Transitions if x["label"][0] == "u"]
    TransEntrees.sort(cmp_label)
    NbTransEntrees = len(TransEntrees)
    TransSorties = [x for x in Transitions if x["label"][0] == "y"]
    TransSorties.sort(cmp_label)
    NbTransSorties = len(TransSorties)
    TransAutres = [x for x in Transitions if x["label"][0] == "x"]
    TransAutres.sort(cmp_label)
    NbTransAutres = len(TransAutres)

    f_out = open(dst,"w")
    f_out.write("// File automaticaly generated by RomeoToMinmaxgd//\n")
    f_out.write("\n")
    f_out.write("A=smatrix(" + str(NbTransAutres) + "," + str(NbTransAutres) + ");\n")
    f_out.write("B=smatrix(" + str(NbTransAutres) + "," + str(NbTransEntrees) + ");\n")
    f_out.write("C=smatrix(" + str(NbTransSorties) + "," + str(NbTransAutres) + ");\n")
    f_out.write("\n")

    for place in Places:
        # trans prec est une entree
        EATP = [ATP for ATP in ArcsTransitionPlace if ATP["place"] == place["id"]]
        if len(EATP) > 1:
            AllErreur(" This is not an event graph\n Please review your Petri Net Model at place " + place["label"] + "\n\n")
        ETransPrec = [t for t in TransEntrees if EATP[0]["transition"] == t["id"]]

        # trans suiv est une sortie
        EAPT = [APT for APT in ArcsPlaceTransition if APT["place"] == place["id"]]
        if len(EATP) > 1:
            AllErreur(" This is not an event graph\n Please review your Petri Net Model at place " + place["label"] + "\n\n")
        ETransSuiv = [t for t in TransSorties if EAPT[0]["transition"] == t["id"]]

        k = place["initialMarking"]
        l = place["label"].split("_")[1]

        if len(ETransPrec) > 0:
            #remplir B
            TransPrec = ETransPrec[0]
            j = str(TransEntrees.index(TransPrec) + 1)
            TransSuiv = [t for t in TransAutres if EAPT[0]["transition"] == t["id"]][0]
            i = str(TransAutres.index(TransSuiv) + 1)
            f_out.write("B(")
        elif len(ETransSuiv) > 0:
            #remplir C
            TransPrec = [t for t in TransAutres if EATP[0]["transition"] == t["id"]][0]
            j = str(TransAutres.index(TransPrec) + 1)
            TransSuiv = ETransSuiv[0]
            i = str(TransSorties.index(TransSuiv) + 1)
            f_out.write("C(")
        else:
            #remplir A
            TransPrec = [t for t in TransAutres if EATP[0]["transition"] == t["id"]][0]
            j = str(TransAutres.index(TransPrec) + 1)
            TransSuiv = [t for t in TransAutres if EAPT[0]["transition"] == t["id"]][0]
            i = str(TransAutres.index(TransSuiv) + 1)
            f_out.write("A(")

        f_out.write(i + "," + j + ")=series([" + k + " " + l + "]);\n")

    f_out.write("\nH=C*stargd(A)*B;\n\n")

    f_out.write("//Precompensateur neutre optimal\n")
    f_out.write("Popt=prcaus(H \H);\n\n")

    f_out.write("//Retour de sortie neutre optimal\n")
    f_out.write("Fopt=prcaus(H \H/H);\n\n")

    f_out.close()


def GuiGetFile(Titre):
    main = Tkinter.Tk()
    main.withdraw()
    filename = tkFileDialog.askopenfilename(title=Titre)
    if filename == "":
        AllErreur("Abandon")
    return filename

def GuiSaveFile(Titre):
    main = Tkinter.Tk()
    main.withdraw()
    filename = tkFileDialog.asksaveasfilename(title=Titre)
    if filename == "":
        AllErreur("Abandon")
    return filename

class destroyer:
    def __init__(self, window):
        self.window = window
    def __call__(self):
        self.window.destroy()

def GuiErreur(erreur):
    tkMessageBox.showerror("Erreur",erreur)
    sys.exit(1)

def CmdErreur(erreur):
    sys.stderr.write(erreur+"\n")
    sys.stderr.flush()
    sys.exit(1)

def GuiDone():
    tkMessageBox.showinfo("All is OK","Done !")

def CmdDone():
    sys.stdout.write("\nDone !\n")

if __name__ == "__main__":
    if len(sys.argv) == 1:
        fichier_source = GuiGetFile("Ouvrir un fichier *.xml source")
        fichier_destin = GuiSaveFile("Choisir un fichier *.scilab destination")
        AllErreur = GuiErreur
        AllDone = GuiDone
    elif len(sys.argv) == 3:
        fichier_source = sys.argv[1]
        fichier_destin = sys.argv[2]
        AllErreur = CmdErreur
        AllDone = CmdDone
    else:
        CmdErreur(" Invalid number of arguments.\n Usage : RomeoToMinmaxgd file.xml file.scilab\n\n")

TransformeFichier(fichier_source, fichier_destin)

AllDone()

